#include <PalmOS.h>
#include "miko2.res.h"
//#include "sin.txt"

DmOpenRef dbp;

const UInt16 stNone            = 0;//enum
const UInt16 stPrintMessage    = 1;
const UInt16 stScrollMessage   = 2;
const UInt16 stKeyWaitNextpage = 3;
const UInt16 stKeyWaitNextline = 4;
const UInt16 stTimeWait        = 5;
const UInt16 stSelect          = 6;
const UInt16 stEnd             = 7;

//Ȃ񂩒mPalmŏԂi[ꍇA
//ϐO[oŎĂKv̂H I don't like this..
Char    g_ScenarioMessage[1024];
 Int16  g_ScenarioNum        = 1000;  /*Beginning Point*/
UInt16  g_IntervalInitial    = 4;
UInt16  g_Interval           = 0;
UInt16  g_Status             = stNone;
 Int16  g_ScrollMessagePhase = 0;
UInt16  g_TimeWaitValue      = 0;
UInt16  g_SelectIndex[2];

UInt16 g_MessagePosX = 3;
UInt16 g_MessagePosY = 120;
UInt16 g_MessagePosC = 0;

void winScreenModeSet4bpp(void){
  UInt32 width, height, depth;
  Boolean enableColor;
  WinScreenMode(winScreenModeGet,&width,&height,&depth,&enableColor);
  depth = 4;
  WinScreenMode(winScreenModeSet,&width,&height,&depth,&enableColor);
}

void winDrawBitmapMiko(UInt16 index){
  MemHandle bitmaphandle;
  BitmapType *mp;
  bitmaphandle=DmGet1Resource('Tbmp', index);
  mp=(BitmapType *)MemHandleLock(bitmaphandle);
  WinDrawBitmap(mp, 0, 0);
  MemHandleUnlock(bitmaphandle);
  DmReleaseResource(bitmaphandle);
}

static Err StartApplication(void)
{
  dbp = DmOpenDatabaseByTypeCreator('appl', 'WGM2', dmModeReadOnly);
  FrmGotoForm(Miko2Form);
  return 0;
}

static void StopApplication(void)
{
  FrmCloseAllForms();
  DmCloseDatabase(dbp);
}

void ReadScenario(UInt16 index)
{
  /*CjVCY*/
  g_Status=stPrintMessage;
  g_MessagePosC=0;

  /*g_ScenarioMessageɒǉ*/
  MemHandle stringhandle;
  Char *mp;
  stringhandle=DmGet1Resource('tSTR', index);
  mp=(Char *)MemHandleLock(stringhandle);
  UInt32 n=0;
  while(mp[n]!=NULL){
    g_ScenarioMessage[n]=mp[n];
    n++;
  }
  g_ScenarioMessage[n]=NULL;
  MemHandleUnlock(stringhandle);
}

void MessageJump(Int16 index){
//  g_ScenarioNum=1000;
  while(1){
    ReadScenario(g_ScenarioNum++);
    if(g_ScenarioMessage[0]=='*'
     &&g_ScenarioMessage[1]=='I'
     &&index==StrAToI(g_ScenarioMessage+3)){break;}
  }
}

void ScrollMessage(void)
{
  /*XN[*/
  if(g_ScrollMessagePhase<FntCharHeight()){
    RectangleType rp;
    RctSetRectangle(&rp, 0, 120+1,160,38);
    WinCopyRectangle(NULL, NULL, &rp, 0, 120, winPaint);
    RctSetRectangle(&rp, 0, 160-1,160,1);
    WinEraseRectangle(&rp, 0);
    g_ScrollMessagePhase++;
  }else{
    g_Status=stPrintMessage;
    g_ScrollMessagePhase=0;
  }
}

void PrintMessage(void)
{
  WChar c;

  /*r[փViI\*/
  c = TxtGetChar(g_ScenarioMessage, g_MessagePosC);
  if(c==NULL){
    g_Status=stNone;
    return;
  }

  if(g_MessagePosX+TxtCharWidth(c)>160){
    //s
    g_MessagePosX=3;
    if((g_MessagePosY+FntCharHeight())+FntCharHeight()>160){
      //vXN[
      g_Status=stScrollMessage;
      return;
    }
    g_MessagePosY+=FntCharHeight();
    return;
  }

  WinDrawChar(c, g_MessagePosX, g_MessagePosY);
  if((g_ScenarioMessage[g_MessagePosC]  ==(Char)0x81
  && g_ScenarioMessage[g_MessagePosC+1]==(Char)0x41)/*uAv*/
  ||(g_ScenarioMessage[g_MessagePosC]  ==(Char)0x81
  && g_ScenarioMessage[g_MessagePosC+1]==(Char)0x5c)/*u\v*/
  ||(g_ScenarioMessage[g_MessagePosC]  ==(Char)0x81
  && g_ScenarioMessage[g_MessagePosC+1]==(Char)0x75)/*wux*/
  ||(g_ScenarioMessage[g_MessagePosC]  ==(Char)0x81
  && g_ScenarioMessage[g_MessagePosC+1]==(Char)0x76)/*wvx*/
  ||(g_ScenarioMessage[g_MessagePosC]  ==(Char)0x81
  && g_ScenarioMessage[g_MessagePosC+1]==(Char)0x63)/*wcx*/
  ){
    g_Interval+=g_IntervalInitial*4;
  }else if((g_ScenarioMessage[g_MessagePosC]  ==(Char)0x81
    && g_ScenarioMessage[g_MessagePosC+1]==(Char)0x42)/*uBv*/
  ){
    g_Interval+=g_IntervalInitial*8;
  }
  g_MessagePosC+=TxtCharSize(c);
  g_MessagePosX+=TxtCharWidth(c);
}

static Boolean MyFormHandleEvent(EventPtr event)
{
  Boolean handled = false;

  switch(event->eType){
    case nilEvent:
      switch(g_Status){
        case stPrintMessage:
          if(g_Interval>0){
            g_Interval--;
          }else{
            PrintMessage();
            g_Interval+=g_IntervalInitial;
          }
          break;
        case stScrollMessage:
          if(g_Interval>0){
            g_Interval--;
          }else{
            ScrollMessage();
            g_Interval++;//+=g_IntervalInitial;
          }
          break;
        case stKeyWaitNextpage:
        case stKeyWaitNextline:
          {
          //CWP[^̕\
          static UInt16 iFlagI=0;
          WinSetForeColor(iFlagI<16?iFlagI:(31-iFlagI));
          WinDrawLine(0,159,159,159);
          WinSetForeColor(0);
          iFlagI=((iFlagI+1)%31);
          }
          break;
        case stTimeWait:
          if(g_TimeWaitValue>0){g_TimeWaitValue--;}else{g_Status=stNone;}
          break;
        case stSelect:
          break;
        case stEnd:
          break;
        default:
          ReadScenario(g_ScenarioNum);g_ScenarioNum++;
          if(g_ScenarioMessage[0]=='*'){
            if(g_ScenarioMessage[1]=='P'){//
              g_Status = stKeyWaitNextpage;
            }else if(g_ScenarioMessage[1]=='L'){//s
              g_Status = stKeyWaitNextline;
            }else if(g_ScenarioMessage[1]=='O'){//ʃNA
              RectangleType rp;
              RctSetRectangle(&rp, 0, 0,160,160);
              WinEraseRectangle(&rp, 0);
              g_Status = stNone;
              g_MessagePosX=3;g_MessagePosY = 120;g_MessagePosC = 0;
            }else if(g_ScenarioMessage[1]=='G'){//摜\
              winDrawBitmapMiko(StrAToI(g_ScenarioMessage+3));
              g_Status = stNone;
            }else if(g_ScenarioMessage[1]=='S'){//Select
              //ʏƎ̃bZ[W\
              g_MessagePosX=3; g_MessagePosY=120;
              /*ViIʂ̃NA*/
              RectangleType rp;
              RctSetRectangle(&rp, 0, 120,160,40);
              WinEraseRectangle(&rp, 0);
              //I\
              g_SelectIndex[0]=StrAToI(g_ScenarioMessage+3);
              ReadScenario(g_ScenarioNum);g_ScenarioNum++;
              WinDrawChars(g_ScenarioMessage,StrLen(g_ScenarioMessage),
                           g_MessagePosX,g_MessagePosY);
              g_MessagePosX=3;g_MessagePosY+=FntCharHeight();
              ReadScenario(g_ScenarioNum);g_ScenarioNum++;
              g_SelectIndex[1]=StrAToI(g_ScenarioMessage+3);
              ReadScenario(g_ScenarioNum);g_ScenarioNum++;
              WinDrawChars(g_ScenarioMessage,StrLen(g_ScenarioMessage),
                           g_MessagePosX,g_MessagePosY);
              g_Status=stSelect;
            }else if(g_ScenarioMessage[1]=='J'){//Jump
              MessageJump(StrAToI(g_ScenarioMessage+3));
              g_Status=stNone;
            }else if(g_ScenarioMessage[1]=='I'){//Index
              g_Status=stNone;
            }else if(g_ScenarioMessage[1]=='W'){//Wait
              g_Status = stTimeWait;
              g_TimeWaitValue = StrAToI(g_ScenarioMessage+3);
            }else if(g_ScenarioMessage[1]=='E'){//END
              /*ViIʂ̃NA*/
              RectangleType rp;
              RctSetRectangle(&rp, 0, 120,160,40);
              WinEraseRectangle(&rp, 0);
              WinDrawChars("***END***",StrLen("***END***"),
                           3,120);
              g_Status=stEnd;
            }else{
              //m̃R}h
            }
          }else{
          }
          break;
      }
      handled = true;
      break;

    case penDownEvent:
     if(g_Status==stKeyWaitNextpage){
       //ʏƎ̃bZ[W\
       g_MessagePosX=3; g_MessagePosY=120;
       /*ViIʂ̃NA*/
       RectangleType rp;
       RctSetRectangle(&rp, 0, 120,160,40);
       WinEraseRectangle(&rp, 0);
       g_Status=stNone;
     }else if(g_Status==stKeyWaitNextline){
       //̃bZ[W\
       g_MessagePosX=160;
       g_Status=stNone;
     }else if(g_Status==stEnd){
       //NOP
     }else if(g_Status==stSelect){
       //I
       if( (120<=(event->screenY))
        && ((event->screenY)<120+FntCharHeight()) ){
              /*ViIʂ̃NA*/
              RectangleType rp;
              RctSetRectangle(&rp, 0, 120,160,40);
              WinEraseRectangle(&rp, 0);
         MessageJump(g_SelectIndex[0]);
         g_Status=stNone;
       }else if( (120+FntCharHeight()<=(event->screenY))
              && ((event->screenY)<120+FntCharHeight()+FntCharHeight()) ){
              /*ViIʂ̃NA*/
              RectangleType rp;
              RctSetRectangle(&rp, 0, 120,160,40);
              WinEraseRectangle(&rp, 0);
         MessageJump(g_SelectIndex[1]);
         g_Status=stNone;
       }
     }else{
       while(g_Status!=stNone){
         //bZ[WXLbv
         if(g_Status==stTimeWait){
           g_TimeWaitValue=0;g_Status=stNone;
         }else if(g_Status==stScrollMessage){
           ScrollMessage();
         }else if(g_Status==stPrintMessage){
           PrintMessage();
         }
       }
       g_Interval = 0;
     }
     handled = true;
     break;

    case frmOpenEvent:
      winScreenModeSet4bpp();
      handled = true;
      break;

    default:
      break;
  }
  return handled;
}


static Boolean ApplicationHandleEvent(EventPtr event)
{
  FormPtr frm;
  Int16 formId;
  Boolean handled = false;

  if(event->eType == frmLoadEvent){
    formId = event->data.frmLoad.formID;
    frm = FrmInitForm(formId);
    FrmSetActiveForm(frm);

    switch(formId){
      case Miko2Form:
        FrmSetEventHandler(frm, MyFormHandleEvent);
        break;
    }
    handled = true;
  }
  return handled;
}


static void EventLoop(void)
{
  EventType event;
  UInt16 error;

  do{
    EvtGetEvent(&event, 1/*evtWaitForever*/);
    if(!SysHandleEvent(&event)){
      if(!MenuHandleEvent(0, &event, &error)){
        if(!ApplicationHandleEvent(&event)){
          FrmDispatchEvent(&event);
        }
      }
    }
  }while(event.eType != appStopEvent);

}


UInt32 PilotMain(UInt16 launchCode, MemPtr cmdPBP, UInt16 launchFlags)
{
  Err err = 0;

  if(launchCode == sysAppLaunchCmdNormalLaunch){
    if((err = StartApplication()) == 0){
      EventLoop();
      StopApplication();
    }
  }

  return err;
}

